import pandas as pd
import matplotlib
matplotlib.use('Agg')
from matplotlib_venn import venn2, venn2_circles
import matplotlib.pyplot as plt
import sys


chr = sys.argv[1]
hmst_file = sys.argv[2]
methylkit_file = sys.argv[3]

df_hmst = pd.read_csv(hmst_file, header=None, names=['sites'])
df_methylkit = pd.read_csv(methylkit_file, header=None, names=['sites'])

venn2([set(df_hmst.sites.tolist()), set(df_methylkit.sites.tolist())],
    set_labels=('HMST-Seq-Analyzer sites', 'MethylKit sites'))

plt.title('CG sites comparison - '+chr)
plt.savefig(chr+'_comparison_sites_venn_diagram.png')
