import pandas as pd
import numpy as np
import sys

def write_HMST_sites_toFile(file_list, chr, output_file):
    sites_common = []
    sites_all = []

    for file in file_list:
        df = pd.read_csv(file)
        s = pd.DataFrame([x.split('||') for x in list(df.name_comb)])
        if 'intergenic' in file:
            KO_sites = s[3]
            WT_sites = s[8]
        else:
            KO_sites = s[4]
            WT_sites = s[10]

        for i in range(len(df)):
            KO_tmp = list(map(int, KO_sites[i].split(',')))
            WT_tmp = list(map(int, WT_sites[i].split(',')))
            both_tmp = KO_tmp+WT_tmp

            common_tmp = list(set(KO_tmp).intersection(WT_tmp))
            sites_common = sites_common + common_tmp

            union_tmp = list(np.unique(np.array(both_tmp)))
            sites_all = sites_all + union_tmp

    unique_sites_all = np.unique(np.array(sites_all))
    unique_sites_all = [chr+'_'+str(s) for s in unique_sites_all]
    df1 = pd.DataFrame(unique_sites_all)
    df1.to_csv(output_file+'union.csv', header=False, index=False)

    unique_sites_common = np.unique(np.array(sites_common))
    unique_sites_common = [chr+'_'+str(s) for s in unique_sites_common]
    df2 = pd.DataFrame(unique_sites_common)
    df2.to_csv(output_file+'common.csv', header=False, index=False)

chr = sys.argv[1]
files = []
files.append(sys.argv[2])
files.append(sys.argv[3])
files.append(sys.argv[4])
files.append(sys.argv[5])
files.append(sys.argv[6])

new = []
for f in files:
    if '*' in f:
        continue;
    else:
        new.append(f)

write_HMST_sites_toFile(new, chr, chr+'_HMST_sites')
