args = commandArgs(trailingOnly=TRUE)

chr = args[1]

library('methylKit')

file.list = list(paste("../in_data/human/WGBS-data/", chr, "/GM12878.hg38.", chr, ".bed", sep=""), paste("../in_data/human/WGBS-data/", chr, "/H1.hg38.", chr, ".bed", sep=""))

myobj = methRead(file.list,
                 pipeline=list(fraction=TRUE,chr.col=1,start.col=2,end.col=3,coverage.col=5,freqC.col=4,strand.col=6),
                 header=FALSE,
                 sample.id=list("test", "control"),
                 assembly="hg38",
                 treatment=c(1, 0),
                 context="CpG"
)

meth=unite(myobj)

myDiff=calculateDiffMeth(meth)
myDiff25p=getMethylDiff(myDiff)
out=getData(myDiff25p)

write.table(out[, c('chr', 'start')], sep="_", row.names=FALSE, col.names=FALSE, quote=FALSE, file=paste(chr, "_methylKit_sites.txt", sep=""))
