#https://bioconductor.org/packages/release/bioc/vignettes/methylSig/inst/doc/using-methylSig.html

#module load R/4.0.0-foss-2020a
#R
library(methylSig)

args = commandArgs(trailingOnly = TRUE)

load(file=paste("BS4samples.chr",args[1],".rda", sep=""))

#check data
#head(GenomicRanges::granges(BS4samples.chr22))
#head(bsseq::getCoverage(BS4samples.chr22 , type='M'))
#head(bsseq::getCoverage(BS4samples.chr22 , type='Cov'))
#head(bsseq::start(BS4samples.chr22))
#head(bsseq::seqnames(BS4samples.chr22))
#bsseq::sampleNames(BS4samples.chr22)
#bsseq::pData(BS4samples.chr22)
#dim(BS4samples.chr22)
#head(bsseq::getMeth(BS4samples.chr22,type="raw"))

#data smooth
BS4samples.chr22.fit<-bsseq::BSmooth(BS4samples.chr22)
BS4samples.chr22.cov <- bsseq::getCoverage(BS4samples.chr22.fit)
#keep rows with at least one column has >=4 coverage
keepLoci.ex <- which(rowSums(BS4samples.chr22.cov[, c("imr90_r1", "imr90_r2")] >= 4) >= 2 &
                     rowSums(BS4samples.chr22.cov[, c("h1_r1", "h1_r2")] >= 4) >= 2)
BS4samples.chr22.fit.filtered= BS4samples.chr22.fit[keepLoci.ex,]
bsseq::pData(BS4samples.chr22.fit.filtered)$Type<-c('imr90','imr90','h1','h1')

#CpG sites differental
#diff_gr = diff_methylsig(
#    bs = BS4samples.chr22.fit.filtered,
#    group_column = 'Type',
#    comparison_groups = c('case' = 'imr90', 'control' = 'h1'),
#    disp_groups = c('case' = TRUE, 'control' = TRUE),
#    local_window_size = 0,
#    t_approx = TRUE,
#    n_cores = 1)
#diff_gr

#tiled window analysis
#tile 25bp time=10 minutes,, real 509.12, user 571.94 
#tile 200bp default time=3 minutes real 163.86, user 226.59
#tile 400bp time=
windowed_bs = tile_by_windows(bs = BS4samples.chr22.fit.filtered, win_size = as.numeric(args[2]) )
diff_gr_windowed = diff_methylsig(
    bs = windowed_bs,
    group_column = 'Type',
    comparison_groups = c('case' = 'imr90', 'control' = 'h1'),
    disp_groups = c('case' = TRUE, 'control' = TRUE),
    local_window_size = 0,
    t_approx = TRUE,
    n_cores = 1)

dmrs_windowed<- subset(diff_gr_windowed, pvalue<0.05 & abs(meth_diff)>10)
dmrs_windowed_df= as(dmrs_windowed, "data.frame")

#dmrs0 <- dmrFinder(BS4samples.chr22.tstat, cutoff = c(-4.6, 4.6), verbose = TRUE)
#dmrs <- subset(dmrs0, abs(meanDiff) > 0.1 & n >= 3)

chrs=args[1]
write.table(dmrs_windowed_df[, c('seqnames', 'start','end')], 
            sep="\t", row.names=FALSE, col.names=FALSE, 
            quote=FALSE, file=paste( chrs,"_methylSig_tl",args[2],"b_dmrs_cov4gt2.txt", sep=""))


