import pandas as pd
import numpy as np
import sys
import glob
#this script is modified by wang for all chromosomes counts

def write_HMST_dmrs_toFile(file_list, chrs, output_file):
    dmrs_common = []
    dmrs_all = []

    for file in file_list:
        #file='out_RRBS_isST0_Ttest2K/data/DKO_vs_WT_5mC_TES_imputedWith_zeros_DMRs_all.csv'
        df = pd.read_csv(file)
        s = pd.DataFrame([x.split('||') for x in list(df.name_comb)])

        all_chr=[X.split(':')[0] for X in list(s[0])]


        if 'intergenic' in file:
            KO_sites = s[3]
            WT_sites = s[8]
        else:
            KO_sites = s[4]
            WT_sites = s[10]

        for i in range(len(df)):
            chr_tmp=all_chr[i]
            KO_tmp1 = list(map(int, KO_sites[i].split(',')))
            WT_tmp1 = list(map(int, WT_sites[i].split(',')))
            
            KO_tmp = [chr_tmp+'_' + str(min(KO_tmp1)) + '_' + str(max(KO_tmp1))]
            WT_tmp = [chr_tmp+'_' + str(min(WT_tmp1)) + '_' + str(max(WT_tmp1))]
            #WT_tmp = [chr_tmp+'_' + X.strip() for X in WT_sites[i].split(',')]
            
            both_tmp = KO_tmp+WT_tmp

            common_tmp = list(set(KO_tmp).intersection(WT_tmp))
            dmrs_common = dmrs_common + common_tmp

            #union_tmp = list(np.unique(np.array(both_tmp)))
            union_tmp=list(set(both_tmp))
            dmrs_all = dmrs_all + union_tmp

    #unique_sites_all = np.unique(np.array(sites_all))
    #unique_sites_all = [chr+'_'+str(s) for s in unique_sites_all]
    unique_dmrs_all =set(dmrs_all)
    unique_dmrs_all =[x.split('_') for x in unique_dmrs_all]
    df1 = pd.DataFrame(unique_dmrs_all)
    df1.to_csv(output_file+'_union.csv', sep='\t',header=False, index=False)

    #unique_sites_common = np.unique(np.array(sites_common))
    #unique_sites_common = [chr+'_'+str(s) for s in unique_sites_common]
    unique_dmrs_common = set(dmrs_common)
    unique_dmrs_common = [x.split('_') for x in unique_dmrs_common]
    df2 = pd.DataFrame(unique_dmrs_common)
    df2.to_csv(output_file+'_common.csv', sep='\t',header=False, index=False)

#chr = sys.argv[1]
#files = []
#files.append(sys.argv[2])
#files.append(sys.argv[3])
#files.append(sys.argv[4])
#files.append(sys.argv[5])
#files.append(sys.argv[6])

# chrs='22'
# file_folder=chrs+'_WGBS/data/'
# #file_folder='out_hmst_isST1_ttest_chr22/'
# files=[file_folder + '/*TES*DMRs_all.csv', file_folder+'/*TSS*DMRs_all.csv',
#        file_folder+'/*geneBody*DMRs_all.csv', file_folder+'/*intergenic*DMRs_all.csv', file_folder+'/*5dist*DMRs_all.csv'
#       ]
#
# new = []
# for f in files:
#     if '*' in f:
#         tmp_f=glob.glob(f)
#         new=new+tmp_f
#     else:
#         new.append(f)
# print (new)
# write_HMST_dmrs_toFile(new, chrs, chrs+'_HMST_dmrs')




