#import matplotlib.pyplot as plt
#from matplotlib_venn import venn2
import pandas as pd


def overlap_c_table(chr, f_hmst, f_bsseq, f_hmst_vs_bsseq ):
#read raw HMST
  # f_hmst='22_HMST_dmrs_common_sorted_merged.csv'
  df_hmst=pd.read_csv(f_hmst, sep='\t',header=None)
  df_hmst=df_hmst.drop_duplicates(subset=[0,1,2],keep='last')

  #read raw others
  #first load original input files
  # f_bsseq=['chr22_BSmooth_dmrs_cov4gt2_sorted_merged.txt', 'chr22_methylSig_tl200b_dmrs_cov4gt2_sorted_merged.txt', 'chr22_methylKit_tl200b_dmrs_sorted_merged.txt',
  #    'chr22_methylSig_tl25b_dmrs_cov4gt2_sorted_merged.txt', 'chr22_methylKit_tl25b_dmrs_sorted_merged.txt']

  names=['BSmooth', 'methylSig_200b', 'methylKit_200b', 'methylSig_25b', 'methylKit_25b']
  all_df={}
  loop=0
  for f in f_bsseq:
    df_bsseq=pd.read_csv(f,header=None,sep='\t')
    df_bsseq=df_bsseq.drop_duplicates(subset=[0,1,2],keep='last')
    all_df[names[loop]]=df_bsseq.copy(deep=True)
    #all_df[names[loop]]=df_bsseq.shape
    loop +=1

  #read overlapping results
  # f_hmst_vs_bsseq= ['chr22_HMST_dmrs_common_vs_BSmooth_dmrs.csv','chr22_HMST_dmrs_common_vs_methylsig_tl200_dmrs.csv','chr22_HMST_dmrs_common_vs_methylkit_tl200_dmrs.csv',
  #   'chr22_HMST_dmrs_common_vs_methylsig_tl25_dmrs.csv','chr22_HMST_dmrs_common_vs_methylkit_tl25_dmrs.csv']
  all_overlap_df={}
  for i in range(5):
    df_hmst_vs_bsseq=pd.read_csv(f_hmst_vs_bsseq[i],sep='\t',header=None)
    uq_hmst_df_hmst_vs_bsseq=df_hmst_vs_bsseq.drop_duplicates(subset=[0,1,2], keep='last')
    uq_bsseq_df_hmst_vs_bsseq=df_hmst_vs_bsseq.drop_duplicates(subset=[4,5,6],keep='last')
    all_overlap_df[names[i]] = [uq_hmst_df_hmst_vs_bsseq.shape, uq_bsseq_df_hmst_vs_bsseq.shape]

  print(df_hmst.shape, df_bsseq.shape)
  print(uq_hmst_df_hmst_vs_bsseq.shape, uq_bsseq_df_hmst_vs_bsseq.shape)

  #build output matrix
  matrix=[]
  matrix0=[df_hmst.shape[0], df_hmst.shape[0], df_hmst.shape[0]/df_hmst.shape[0] ,  (abs(df_hmst[1]-df_hmst[2]-1)).median().astype(int),0,0,0 ]
  matrix.append(matrix0)
  for kk in names:
    tmp_vect=[all_df[kk].shape[0], all_overlap_df[kk][1][0], float(all_overlap_df[kk][1][0])/all_df[kk].shape[0], abs(all_df[kk][1]-all_df[kk][2]-1).median().astype(int),0,0,0]
    #all_df[kk]
    #all_overlap_df[kk]
    matrix.append(tmp_vect)

  #matrix=[[df_hmst.shape[0], uq_hmst_df_hmst_vs_bsseq.shape[0] , (abs(df_hmst[1]-df_hmst[2])).median().astype(int) ],
  #        [df_bsseq.shape[0], uq_bsseq_df_hmst_vs_bsseq.shape[0] ,(abs(df_bsseq[1]-df_bsseq[2])).median().astype(int)]  ]


  out_df=pd.DataFrame(matrix)
  out_df.columns=['DMRs','overlapping_HMST','percentage','DMR_length', 'DMR_finding','gene_annotation','total']
  out_df.index=['hmst']+ names

  out_f='chr'+chr+'_hmst_vs_all_tl200_25_common_count.csv'
  out_df.to_csv(out_f,sep='\t')

  # First way to call the 2 group Venn diagram:
  #venn2(subsets = (10, 5, 2), set_labels = ('Group A', 'Group B'))
  #plt.show()

