#!/bin/bash
echo Demo for HMST

TEST_METHOD='Pranksum'

echo ${TEST_METHOD}

# Do the work
hmst_seq_analyzer gene_annotation -l 2000 -xL 1000000 -M 10000 -N 100000 -F chr1_HMST -hu yes -n no -r in_data/human/hg19.refFlat.txt -g in_data/human/hg19.chrom.sizes.clear.sorted
echo gene_annotation-DONE

hmst_seq_analyzer data_preprocessing -F chr1_HMST -z no -m no -hu yes -n no -fko in_data/human/HMST-Seq-data/cancer_liver/chr1.formatted/cancerliver.chr1.97L.txt -fko in_data/human/HMST-Seq-data/cancer_liver/chr1.formatted/cancerliver.chr1.LM6.txt -fwt in_data/human/HMST-Seq-data/normal_liver/chr1.formatted/normalliver.chr1.N045268.txt -g in_data/human/hg19.chrom.sizes.clear.sorted
echo data_preprocessing-DONE

hmst_seq_analyzer find_MRs -W no -a 2000 -mc1 3 -mc2 5 -mc3 3 -F chr1_HMST -p 5 -fko chr1_HMST/list_mC_hmC_files_KO.txt -fwt chr1_HMST/list_mC_hmC_files_WT.txt -ref chr1_HMST/data/hg19.refFlat_clean_sorted.bed -reg chr1_HMST/list_region_files.txt
echo find_MRs-DONE

hmst_seq_analyzer prepare_for_DMR_finding -isST 1 -a 2000 -mc1 3 -mc2 5 -mc3 3 -F chr1_HMST -p 8 -ko chr1_HMST/list_all_filtered_formatted_MRs_KO.txt -wt chr1_HMST/list_all_filtered_formatted_MRs_WT.txt
echo prepare_for_DMR_finding-DONE

hmst_seq_analyzer DMR_search -T ${TEST_METHOD} -F chr1_HMST -p 8 -f chr1_HMST/list_prepared_for_DMR_finding_imputed.txt
echo DMR_search-DONE

hmst_seq_analyzer prep4plot -F chr1_HMST -ko chr1_HMST/list_all_filtered_formatted_MRs_KO.txt -wt chr1_HMST/list_all_filtered_formatted_MRs_WT.txt
echo prep4plot-DONE

hmst_seq_analyzer plot_all -F chr1_HMST -reg chr1_HMST/list_count_allMRs_regions_files.txt -sit chr1_HMST/list_count_sites_files.txt -cmc chr1_HMST/counts_DMR_hypo_hyper_imputed_${TEST_METHOD}_5mC.csv -chmc chr1_HMST/counts_DMR_hypo_hyper_imputed_${TEST_METHOD}_5hmC.csv -aMR chr1_HMST/list_TSS_genebody_TES_enhancer_allMRs.txt 
echo plot_all-DONE


