#!/bin/bash
echo Demo for RRBS

TEST_METHOD='Pranksum'

echo ${TEST_METHOD}

# Do the work
hmst_seq_analyzer gene_annotation -l 2000 -xL 5000 -F out_RRBS -hu mouse -n yes -M 10000 -N 100000 -r in_data/mouse/mm9.refFlat.txt -g in_data/mouse/mm9.sizes_numerical
echo gene_annotation-DONE

hmst_seq_analyzer data_preprocessing -c 0.4999 -F out_RRBS -z no -m yes -hu no -n yes -fko in_data/mouse/RRBS/DKO_1_CpG.bed -fwt in_data/mouse/RRBS/WT_1_CpG.bed -g in_data/mouse/mm9.sizes_numerical
echo data_preprocessing-DONE

hmst_seq_analyzer find_MRs -W no -a 2000 -mc1 2 -mc2 2 -mc3 2 -F out_RRBS -p 5 -fko out_RRBS/list_mC_hmC_files_KO.txt -fwt out_RRBS/list_mC_hmC_files_WT.txt -ref out_RRBS/data/mm9.refFlat_clean_sorted.bed -reg out_RRBS/list_region_files.txt
echo find_MRs-DONE

hmst_seq_analyzer prepare_for_DMR_finding -isST 1 -a 2000 -mc1 2 -mc2 2 -mc3 2 -F out_RRBS -p 5 -ko out_RRBS/list_all_filtered_formatted_MRs_KO.txt -wt out_RRBS/list_all_filtered_formatted_MRs_WT.txt
echo prepare_for_DMR_finding-DONE

hmst_seq_analyzer DMR_search -T ${TEST_METHOD} -F out_RRBS -p 5 -f out_RRBS/list_prepared_for_DMR_finding_imputed.txt
echo DMR_search-DONE

hmst_seq_analyzer prep4plot -c 0.4999 -F out_RRBS -ko out_RRBS/list_all_filtered_formatted_MRs_KO.txt -wt out_RRBS/list_all_filtered_formatted_MRs_WT.txt
echo prep4plot-DONE

hmst_seq_analyzer plot_all -F out_RRBS -reg out_RRBS/list_count_allMRs_regions_files.txt -sit out_RRBS/list_count_sites_files.txt -cmc out_RRBS/counts_DMR_hypo_hyper_imputed_${TEST_METHOD}_5mC.csv -chmc out_RRBS/counts_DMR_hypo_hyper_imputed_${TEST_METHOD}_5hmC.csv -aMR out_RRBS/list_TSS_genebody_TES_enhancer_allMRs.txt -oMR out_RRBS/list_overlapping_MRs.txt
echo plot_all-DONE
