#!/bin/bash

echo Demo for WGBS

CHR='chr17'
TEST_METHOD='Pranksum'

echo ${TEST_METHOD}

# Do the work
/usr/bin/time -p hmst_seq_analyzer gene_annotation -l 2000 -xL 5000 -F ${CHR}_WGBS -hu yes -n no -M 10000 -N 100000 -r in_data/human/hg38.refFlat.txt -g in_data/human/hg38.chrom.sizes.clear.sorted
echo gene_annotation-DONE

/usr/bin/time -p hmst_seq_analyzer data_preprocessing -F ${CHR}_WGBS -z no -m yes -hu yes -n no -c 0.4999 -fko in_data/human/WGBS-data/${CHR}/GM12878.hg38.${CHR}.bed -fwt in_data/human/WGBS-data/${CHR}/H1.hg38.${CHR}.bed -g in_data/human/hg38.chrom.sizes.clear.sorted
echo data_preprocessing-DONE

/usr/bin/time -p hmst_seq_analyzer find_MRs -W yes -a 200 -mc1 3 -mc2 5 -mc3 3 -F ${CHR}_WGBS -p 5 -fko ${CHR}_WGBS/list_mC_hmC_files_KO.txt -fwt ${CHR}_WGBS/list_mC_hmC_files_WT.txt -ref ${CHR}_WGBS/data/hg38.refFlat_clean_sorted.bed -reg ${CHR}_WGBS/list_region_files.txt
echo find_MRs-DONE

/usr/bin/time -p hmst_seq_analyzer prepare_for_DMR_finding -isST 1 -a 2000 -mc1 3 -mc2 5 -mc3 3 -F ${CHR}_WGBS -p 4 -ko ${CHR}_WGBS/list_all_filtered_formatted_MRs_KO.txt -wt ${CHR}_WGBS/list_all_filtered_formatted_MRs_WT.txt
echo prepare_for_DMR_finding-DONE

/usr/bin/time -p hmst_seq_analyzer DMR_search -F ${CHR}_WGBS -p 5 -f ${CHR}_WGBS/list_prepared_for_DMR_finding_imputed.txt
echo DMR_search-DONE

/usr/bin/time -p hmst_seq_analyzer prep4plot -F ${CHR}_WGBS -c 0.4999 -ko ${CHR}_WGBS/list_all_filtered_formatted_MRs_KO.txt -wt ${CHR}_WGBS/list_all_filtered_formatted_MRs_WT.txt
echo prep4plot-DONE

/usr/bin/time -p hmst_seq_analyzer plot_all -F ${CHR}_WGBS -reg ${CHR}_WGBS/list_count_allMRs_regions_files.txt -sit ${CHR}_WGBS/list_count_sites_files.txt -cmc ${CHR}_WGBS/counts_DMR_hypo_hyper_imputed_${TEST_METHOD}_5mC.csv -chmc ${CHR}_WGBS/counts_DMR_hypo_hyper_imputed_${TEST_METHOD}_5hmC.csv -aMR ${CHR}_WGBS/list_TSS_genebody_TES_enhancer_allMRs.txt -oMR ${CHR}_WGBS/list_overlapping_MRs.txt
echo plot_all-DONE
